LPARAM lcType,lcSL,lcDL,liID
*lcType - GUI, HTML, PDM
*lcSL   - Source language file
*lcDL   - Destination language file
*liID   - ID of string

*****************************************************************
** Program name: changestring.PRG
** Version: 0.1
** Create date: 2004-06-13
** Description: Change string in destination language table by source language table
** If String not exist in destination table, will be created
** Author: Martin Jindra
** E-mail: martin.jindra@egservis.cz
** CP: 1250

** All warnings shows in Debug Output

** Using:
** ------
** 
** Synchrononize French language with English language for HTML
** English language - source, French language - destination
** DO changestring with "HTML","EN", "FR", 100

** Synchrononize French language with English language for GUI
** English language - source, French language - destination
** DO changestring with "GUI","EN", "FR", 1 &&

** Synchrononize other languages with English language for HTML
** English language - source
** DO changestring with "HTML","EN", "", 100

** Synchrononize other languages with English language for GUI
** English language - source
** DO changestring with "GUI","EN", "", 1


LOCAL lcPath,lcFileS,lcFileD,lcSA,lcDA,liXX000,lcXX001,lii,liCount,liy
LOCAL ARRAY laLang(1),laDir(1)
lcPath=SYS(16)
lcPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)

lcPath=lcPath+IIF(lcType=="HTML" OR lcType=="PDM","lang\","gui\lang\")

lcFileS=lcPath+IIF(lcType=="HTML",ALLT(lcSL)+"\html.dbf",ALLT(lcSL)+"\pdm.dbf")

lcSA=SYS(2015)
lcDA=SYS(2015)

IF !OpenTable(lcFileS,lcSA," SHARE ORDER XXI000")
   =MESSAGEBOX("Cannot open file "+lcFileS+".")
   RETURN
ENDIF

SELE (lcSA)
IF !SEEK(liID)
   =MESSAGEBOX("String ID "+LTRIM(STR(liID,11))+" not found.")
   USE IN (lcSA)
   RETURN
ENDIF

IF EMPTY(lcDL)
   liCount=ADIR(laDir,lcPath+"*.*","ASHRD")

   DIME lalang(liCount)
   liy=0
   FOR lii=1 TO liCount
       IF AT("D",laDir(lii,5))>0 AND !(laDir(lii,1)=="." OR laDir(lii,1)==".." OR LOWER(laDir(lii,1))==LOWER(ALLT(lcSL)))
          liy=liy+1
          laLang(liy)=laDir(lii,1)
       ENDIF
   NEXT

   IF liy>0
      DIME laLang(liy)
   ELSE
      =MESSAGEBOX("No language.")
      USE IN (lcSA)
      RETURN
   ENDIF
ELSE
   laLang(1)=ALLT(lcDL)
   liy=1
ENDIF


llShowSame=IIF(PCOUNT()<5,.T.,llShowSame)

SELE (lcSA)
liXX000=XX000
lcXX001=XX001


FOR lii=1 TO liy
    lcFileD=lcPath+IIF(lcType=="HTML",laLang(lii)+"\html.dbf",laLang(lii)+"\pdm.dbf")

    IF !OpenTable(lcFileD,lcDA," SHARE ORDER XXI000")
       =MESSAGEBOX("Cannot open file "+lcFileD+".")
       RETURN
    ENDIF
    debugout "************************"
    debugout lcFileD

    SELE (lcDA)
    IF !SEEK(liXX000)
       debugout "Lost"+STR(liXX000,11)+" "+lcXX001
       INSER INTO (lcDA) (XX000,XX001) VALUES (liXX000,lcXX001)
    ELSE
       REPL XX001 WITH lcXX001
    ENDIF
    USE IN (lcDA)
NEXT
USE IN (lcSA)

********************************************
PROCEDURE OpenTable(lcFile,lcAlias,lcParam)
LOCAL llErr,lcErr
lcErr=ON("ERROR")
ON ERROR llErr=.T.
USE (lcFile) ALIAS (lcAlias) &lcParam. IN 0

IF EMPTY(lcErr)
   ON ERROR
ELSE
   ON ERROR &lcErr.
ENDIF
RETURN !llErr