#INCLUDE "vf_base.h"

*************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_vf_base",lcCollate)


***********************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_vf_base_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_vf_base_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)


*******************************************************
DEFINE CLASS _vf_base AS _pdm_PlugIn && 
   Name="_vf_base"

   ID=50000         && ID of Plug-in
   Type="VF" && Typ of plug-in (group)

   Setting=.NULL.
   Par=.NULL.
   Alias=""
   
  
   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang


      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         llEn=.F.
         SELE (This.ALTab)
         SET ORDER TO "I01"
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "Value formating")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, "Value formating plug-in")


         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (XX010_CAP,"Class")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (XX020_CAP,"Property")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (XX030_CAP,"Mode")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (XX040_CAP,"First")

         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (XX030_1_CAP,"None")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (XX030_2_CAP,"All")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (XX030_3_CAP,"First n characters")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (XX030_4_CAP,"Auto")

         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (_frmVF_Add_TTT,"Add value formating")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (_frmVF_Save_TTT,"Save value formating")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (_frmVF_Dele_TTT,"Drop value formating")

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
      SET DELETED ON
   ENDPROC


   PROCEDURE Run(loPar,loSetting) && Main procedure
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in

      LOCAL m.lcUProp,liz,luValue,lcIMG,lcTab,lcPom,lcDBC,lcACT,luValueX,loPDM,loPDMs,lcSP,llLNKS,lcPomRel,lcShortVal,;
            llShortVal,lcFullValue,lcBottomHTML,lcPict,lcDisp,lcClass
      LOCAL ARRAY laSO(1,1)
      
      m.lcUProp=UPPER(loPar.cPEM)
      m.loPDM=EVAL(m.This.PDM)
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      lcSP=IIF(m.loPDM.FormatSpace=_Format_No,"",SPACE(m.loPar.iLevel))
      lcPict=loPar.oPDMx.aEC(_EC_Expr,2)
      lcDisp=loPar.oPDMx.aEC(_EC_Expr,3)
      lcClass=UPPER(loPar.cParent)

      STORE "" TO lcFullValue,lcBottomHTML

      * uprava nativnch hodnot
      DO CASE
         CASE m.lcUProp=="_MEMBERDATA"
              liz=AT("<VFPData>",loPar.cValue)
              IF liz>0
                 lix=AT("</VFPData>",loPar.cValue)+LEN("</VFPData>")
                 luValue=SUBSTR(loPar.cValue,liz,lix-liz)
              ELSE
                 luValue=""
              ENDIF

          OTHERWISE
              luValue=loPar.cValue
      ENDCASE

      * oezn hodnoty dle pravidla
      lcShortVal=luValue
*      SET DATASESSION TO (This.DatasessionID)
      SELECT (loSetting.cAlias)
      LOCATE FOR XX010==lcClass AND UPPER(XX020)==m.lcUProp
      IF NOT FOUND()
         LOCATE FOR EMPTY(XX010) AND UPPER(XX020)==m.lcUProp
      ENDIF   
      IF FOUND()
         DO CASE
            CASE XX030="1" && None
                 lcShortVal=""
            CASE XX030="2" && All
                 lcShortVal=luValue
            CASE XX030="3" && First n chars
                 lcShortVal=LEFT(luValue,XX040)
            CASE XX030="4" && Auto (filename)
                 lcShortVal=ExtractFileFromFile(luValue)

         ENDCASE
         llShortVal=NOT lcShortVal==luValue
      ENDIF

      * formtovn hodnot
      DO CASE
         CASE (INLIST(m.lcUProp,"ICON","PICTURE","DOWNPICTURE","DISABLEDPICTURE","MOUSEICON","DRAGICON","DATABASE","CURSORSOURCE","AUTOCOMPTABLE") OR;
              m.loPar.lNative AND INLIST(m.lcUProp,"TAG","TABLES")) AND !EMPTY(m.luValue)
              * Odstra z luValue uvozujc znaky etzce
              luValue=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)

              DO CASE
                 CASE INLIST(m.lcUProp,"ICON","PICTURE","DOWNPICTURE","DISABLEDPICTURE","MOUSEICON","DRAGICON") 
                      lcIMG=FULLPATH(m.luValue,ExtractPathFromFile(m.loPar.File))
                      m.loPDM.AddFileToRepository(m.lcIMG,m.loPar.cPath,@m.lcPom)
                      loPar.lPicture=.T.
                      lcHTMLVAL='<a href="'+m.lcPom+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05239),"%name%",ExtractFileFromFile(m.luValue))+'">'+StrTranHTMLString(lcShortVal)+'</a>'
                      m.loPDM.AddFileToRepository(m.lcIMG,m.loPDM.OutDir,@m.lcPomRel)
                      loPar.cPomRel=lcPomRel

                 CASE m.lcUProp=="CURSORSOURCE"
                      loPar.lData=.T.
                      lcTab=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                      lcPom=m.loPDMs.GetAnchor(IIF(!m.loPar.lDBC,;
                                                   FULLPATH(m.lcTab,ExtractPathFromFile(m.loPar.File)),;
                                                   FULLPATH(m.loPar.cDBC,ExtractPathFromFile(m.loPar.File))+"!"+m.lcTab),m.loPar.cDir)
*!*	                      IF !EMPTY(lcPom)

*FREE TABLE
*!*	                   lcStringFLD=lcStringFLD+;
*!*	                              <a href="'+loPDMs.DBC.HTMLUni+"?next="+lcAnchor+'"

* tables
*!*	                   lcStringFLD=lcStringFLD+;           dbc\Main.htm           Main_uni.htm              table name
*!*	                               <a target="_top" href="'+This.FileName+"/"+lcHTML_Uni+"?next="+LOWER(STRTRAN(lcName," ","."))+'.htm"
                         
*!*	                      ENDIF
                                                   
                      lcHTMLVAL=IIF(EMPTY(m.lcPom),StrTranHTMLString(m.luValue),;
                                '<a href="'+m.lcPom+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(IIF(!m.loPar.lDBC,PDM_05167,PDM_05143)),"%name%",ExtractFileFromFile(m.luValue))+'">'+StrTranHTMLString(lcShortVal)+'</a>')

                 CASE m.lcUProp=="DATABASE"
                      loPar.lData=.T.
                      lcDBC=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                      lcPom=m.loPDMs.GetAnchor(FULLPATH(m.lcDBC,ExtractPathFromFile(m.loPar.File)),m.loPar.cDir)
                      lcHTMLVAL=IIF(EMPTY(m.lcPom),StrTranHTMLString(m.luValue),;
                                '<a href="'+m.lcPom+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05161),"%name%",ExtractFileFromFile(m.luValue))+'">'+StrTranHTMLString(lcShortVal)+'</a>')

                 CASE m.lcUProp=="AUTOCOMPTABLE"
                      loPar.lData=.T.
                      lcACT=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                      lcPom=m.loPDMs.GetAnchor(FULLPATH(m.lcACT,ExtractPathFromFile(m.loPar.File)),m.loPar.cDir)
                      lcHTMLVAL=IIF(EMPTY(m.lcPom),StrTranHTMLString(m.luValue),;
                                [<a href="]+m.lcPom+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05143),"%name%",ExtractFileFromFile(m.luValue))+[">]+StrTranHTMLString(lcShortVal)+[</a>])+m.loPDM.aSpace(21)

                 CASE m.loPar.lNative AND m.lcUProp=="TAG" AND !EMPTY(loPar.cDBC)
                      loPar.lData=.T.
                      lcDBC=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                      lcPom=m.loPDMs.GetAnchor(FULLPATH(lcDBC,ExtractPathFromFile(m.loPar.File)),m.loPar.cDir)
                      lcHTMLVAL=IIF(EMPTY(m.lcPom),StrTranHTMLString(m.luValue),;
                                '<a href="'+m.lcPom+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05161),"%name%",ExtractFileFromFile(m.luValue))+'">'+StrTranHTMLString(lcShortVal)+'</a>')

                 CASE m.loPar.Native AND m.lcUProp=="TABLES" AND !EMPTY(loPar.cDBC)
                      loPar.lData=.T.
                      lcTab=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                      liz=ALINES(laRows,STRTRAN(m.lcTab,",",CRLF))
                      lcDBC=FULLPATH(m.loPar.cDBC,ExtractPathFromFile(m.loPar.File))
                      IF m.liz=1
                         lcPom=m.loPDMs.GetAnchor(m.lcDBC+"!"+laRows(1),m.loPar.cDir)
                         lcHTMLVAL=IIF(EMPTY(m.lcPom),StrTranHTMLString(lcShortVal),;
                                   [<a href="]+m.lcPom+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05143),"%name%",ExtractFileFromFile(m.luValue))+[">]+StrTranHTMLString(lcShortVal)+[</a>])+m.loPDM.aSpace(21)
                      ELSE
                         lcHTMLVAL=CRLF+;
                                   m.lcSP+m.loPDM.aSpace(4)+[<span id="SPN_]+m.loPar.cRecnoX+[" class="LNK_collaborative" onclick="pcLNK=']+loPar.cRecnoX+[';" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05143),"%name%",ExtractFileFromFile(m.luValue))+[">]+m.luValue+"</span>"+m.loPDM.aSpace(21)+;
                                   m.lcSP+m.loPDM.aSpace(4)+[<div id="LNK_]+m.loPar.cRecnoX+[" class="LNK_tab"> <!-- Link Table Begin -->]+m.loPDM.aSpace(21)+;
                                   m.lcSP+m.loPDM.aSpace(5)+[<table class="a_center">]+m.loPDM.aSpace(21)

                         FOR m.lix=1 TO m.liz
                             IF !EMPTY(laRows(m.lix))
                                m.This.lLNK=.T.
                                lcPom=m.loPDMs.GetAnchor(m.lcDBC+"!"+laRows(m.lix),m.loPar.cDir)
                                lcHTMLVAL=m.lcHTMLVAL+;
                                          m.lcSP+m.loPDM.aSpace(6)+[<tr><td><a href="]+m.lcPom+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05143),"%name%",laRows(m.lix))+[">]+laRows(m.lix)+[</a></td></tr>]+m.loPDM.aSpace(21)
                             ENDIF
                         NEXT
                         lcHTMLVAL=m.lcHTMLVAL+;
                                   m.lcSP+m.loPDM.aSpace(5)+[</table>]+m.loPDM.aSpace(21)+;
                                   m.lcSP+m.loPDM.aSpace(4)+[</div> <!-- Link Table End -->]+m.loPDM.aSpace(21)
                      ENDIF
                 ENDCASE
                 
         * Otestuj, MemberClassLibrary, HeaderClassLibrary a MemberClass, HeaderClass
         CASE (m.lcUProp=="MEMBERCLASSLIBRARY" OR m.lcUProp=="HEADERCLASSLIBRARY" OR m.lcUProp=="DECLASSLIBRARY" OR ;
               m.lcUProp=="MEMBERCLASS" OR m.lcUProp=="HEADERCLASS" OR m.lcUProp=="DECLASS")

               STORE IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue) TO luValue

               IF !EMPTY(m.luValue)
                  lcPom=UPPER(m.luValue)

                  IF m.lcUProp=="MEMBERCLASSLIBRARY" OR m.lcUProp=="HEADERCLASSLIBRARY" OR m.lcUProp=="DECLASSLIBRARY"
                     STORE .T. TO loPar.lMember
                     * Soubor je definovn
                     lcPom=m.loPDMs.GetAnchor(IIF(m.lcUProp=="MEMBERCLASSLIBRARY",loPar.laMember(1),IIF(m.lcUProp=="HEADERCLASSLIBRARY",loPar.laMember(2),loPar.laMember(3))),"../../")
                     lcHTMLVAL=IIF(EMPTY(m.lcPom),StrTranHTMLString(lcShortVal),;
                               m.loPDM.aSpace(3)+[<a href="]+m.lcPom+[" target="blank" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05113),"%name%",ExtractFileFromFile(m.luValue))+[">]+StrTranHTMLString(lcShortVal)+[</a>])
                  ENDIF

                  * a nen to zkladn tda
                  IF (m.lcUProp=="MEMBERCLASS" OR m.lcUProp=="HEADERCLASS" OR m.lcUProp=="DECLASS") AND ;
                     !(m.lcPom=="CHECKBOX" OR m.lcPom=="COLLECTION" OR m.lcPom=="COLUMN" OR;
                       m.lcPom=="COMBOBOX" OR m.lcPom=="COMMANDBUTTON" OR m.lcPom=="COMMANDGROUP" OR;
                       m.lcPom=="CONTAINER" OR m.lcPom=="CONTROL" OR m.lcPom=="CURSOR" OR;
                       m.lcPom=="CURSORADAPTER" OR m.lcPom=="CUSTOM" OR m.lcPom=="DATAENVIRONMENT" OR;
                       m.lcPom=="EDITBOX" OR m.lcPom=="EXCEPTION" OR m.lcPom=="FORM" OR;
                       m.lcPom=="FORMSET" OR m.lcPom=="GRID" OR m.lcPom=="HEADER" OR;
                       m.lcPom=="HYPERLINK" OR m.lcPom=="IMAGE" OR m.lcPom=="LABEL" OR;
                       m.lcPom=="LINE" OR m.lcPom=="LISTBOX" OR m.lcPom=="OLECONTROL" OR;
                       m.lcPom=="OLEBOUNDCONTROL" OR m.lcPom=="OPTIONBUTTON" OR m.lcPom=="OPTIONGROUP" OR;
                       m.lcPom=="PAGE" OR m.lcPom=="PAGEFRAME" OR m.lcPom=="PROJECTHOOK" OR;
                       m.lcPom=="RELATION" OR m.lcPom=="REPORTLISTENER" OR m.lcPom=="SEPARATOR" OR m.lcPom=="SHAPE" OR;
                       m.lcPom=="SESSION" OR m.lcPom=="SPINNER" OR m.lcPom=="TEXTBOX" OR;
                       m.lcPom=="TIMER" OR m.lcPom=="TOOLBAR" OR m.lcPom=="XMLADAPTER" OR;
                       m.lcPom=="XMLTABLE" OR m.lcPom=="XMLFIELD")

                       STORE .T. TO loPar.lMember

                       IF EMPTY(IIF(m.lcUProp=="MEMBERCLASS",loPar.laMember(1),IIF(m.lcUProp=="HEADERCLASS",loPar.laMember(2),loPar.laMember(3))))
                          liz=m.loPDMs.GetClassAnchors(@laSO,m.luValue,"../../")
                          llLNKS=m.liz=1
                          IF m.llSingle
                             lcPom=laSO(1,1)
                          ENDIF
                       ELSE
                          lcSOFile=IIF(m.lcUProp=="MEMBERCLASS",loPar.laMember(1),IIF(m.lcUProp=="HEADERCLASS",loPar.laMember(2),loPar.laMember(3)))
                          llLNKS=.T.
                          * Soubor je definovn
                          lcPom=m.loPDMs.GetClassAnchor(m.lcSOFile,m.luValue,"../../")
                       ENDIF
          
                       IF m.llLNKS
                          lcHTMLVAL=IIF(EMPTY(m.lcPom),m.luValue,;
                                    [<a href="]+m.lcPom+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",m.luValue)+[">]+StrTranHTMLString(lcShortVal)+[</a>])+m.loPDM.aSpace(21)
                       ELSE
                          m.loPar.lLNK=.T.
                          lcHTMLVAL=m.loPDM.aSpace(21)+;
                                    m.lcSP+m.loPDM.aSpace(4)+[<span id="SPN_]+m.loPar.cRecnoX+[" class="LNK_collaborative" onclick="pcLNK=']+m.loPar.cRecnoX+[';" title="]+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",m.luValue)+[">]+m.luValue+"</span>"+m.loPDM.aSpace(21)+;
                                    m.lcSP+m.loPDM.aSpace(4)+[<div id="LNK_]+m.loPar.cRecnoX+[" class="LNK_tab"> <!-- Link Table Begin -->]+m.loPDM.aSpace(21)+;
                                    m.lcSP+m.loPDM.aSpace(5)+[<table class="a_center">]+m.loPDM.aSpace(21)
                
                           FOR lix=1 TO m.liz
                               lcHTMLVAL=m.lcHTMLVAL+;
                                         m.lcSP+m.loPDM.aSpace(6)+[<tr><td><a href="]+laSO(m.lix,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",m.lcValueX)+[">]+StrTranHTMLString(lcShortVal)+[</a></td></tr>]+m.loPDM.aSpace(21)
       
                           NEXT
                           lcHTMLVAL=m.lcHTMLVAL+;
                                     m.lcSP+m.loPDM.aSpace(5)+[</table>]+m.loPDM.aSpace(21)+;
                                     m.lcSP+m.loPDM.aSpace(4)+[</div> <!-- Link Table End -->]+m.loPDM.aSpace(21)
                        ENDIF
                     ENDIF
                  ENDIF
                    
           CASE llShortVal
                lcHTMLVAL=IIF(LEFT(lcShortVal,1)="(",;
                          m.loPDM.Expr2xhtml(SUBST(lcShortVal,2,LEN(lcShortVal)-2)),;
                          StrTranHTMLString(lcShortVal))

           OTHERWISE
                lcHTMLVAL=IIF(EMPTY(lcShortVal),"&nbsp;",;
                          IIF(LEFT(lcShortVal,1)="(",;
                          m.loPDM.Expr2xhtml(SUBST(lcShortVal,2,LEN(lcShortVal)-2)),;
                          StrTranHTMLString(lcShortVal) ))

      ENDCASE

      IF llShortVal AND NOT EMPTY(m.luValue) && pidej nco co rozbal hodnotu
         lcFullValue=m.lcSP+m.loPDM.aSpace(4)+[<img onclick="ExpandVal(']+m.loPar.cRecnoX+[_1',-1);" class="imgEC" src="../../imgs/]+m.lcPict+[" alt="]+m.loPDMs.aStrings(PDM_04654)+[" id="IMG_]+m.loPar.cRecnoX+[_1" />]+m.loPDM.aSpace(21)+;
                     m.lcSP+m.loPDM.aSpace(4)+[<div ]+IIF(m.loPDM.ECPMDblclick=1,[ondblclick="ExpandVal(']+m.loPar.cRecnoX+[_1',-1);"],"")+[ class="SCE2"]+lcDisp+' id="TX_'+m.loPar.cRecnoX+'_1">'+m.loPDM.aSpace(21)+;
                     m.lcSP+m.loPDM.aSpace(5)+IIF(LEFT(m.luValue,1)="(",;
                         m.loPDM.Expr2xhtml(SUBST(m.luValue,2,LEN(m.luValue)-2)),;
                         StrTranHTMLString(m.luValue))+m.loPDM.aSpace(21)+;
                     m.lcSP+m.loPDM.aSpace(4)+[</div>]+m.loPDM.aSpace(21)
         
         loPar.cScript=loPar.cScript+;
                       STRTRAN(STRTRAN(STRTRAN(m.loPDM.RE,"%ID%",'TX_'+m.loPar.cRecnoX+'_1'),"%XType%","Expression"),"%Dir%","../../imgs/")+m.loPDM.aSpace(21)
      ENDIF

      RETURN lcHTMLVAL+lcFullValue+lcBottomHTML
   ENDPROC



   PROCEDURE GetSetting() &&  Return settings object
      RETURN CREATEOBJECT("_vf_base_par")
   ENDPROC

   PROCEDURE CreateDefaultSettings(loSettings) &&  Create default settings
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","_MEMBERDATA","3",50)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","ICON","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","PICTURE","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","DOWNPICTURE","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","DISABLEDPICTURE","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","MOUSEICON","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","DRAGICON","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","CURSORSOURCE","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","DATABASE","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","AUTOCOMPTABLE","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","MEMBERCLASSLIBRARY","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","HEADERCLASSLIBRARY","4",0)
      INSERT INTO (loSettings.cAlias) (XX010,XX020,XX030,XX040) VALUES ("","DECLASSLIBRARY","4",0)
      RETURN .T.
   ENDPROC

   PROCEDURE Open(lcFile,loSettings) && Load settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcXX010,lcXX020,lcXX030,lnXX040,liS,liE,lcRow
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      lcData=GetINISection(lcSection+"_Items",32000,@lcFile) && Cel sekce
      IF !EMPTY(lcData)
         liCount=ALINES(laPom,STRTRAN(lcData,CHR(0),CHR(13)+CHR(10))) && Nati dky
         lcData=""
         FOR lii=1 TO liCount
             lcRow=SUBST(laPom(lii),2)
             liS=AT(";",lcRow,1)
             liE=AT(";",lcRow,2)
             lcXX010=SUBSTR(lcRow,liS+1,liE-liS-1)

             liS=liE
             liE=AT(";",lcRow,3)
             lcXX020=SUBSTR(lcRow,liS+1,liE-liS-1)
             
             liS=liE
             liE=AT(";",lcRow,4)
             lcXX030=SUBSTR(lcRow,liS+1,liE-liS-1)

             liS=liE
             liE=AT(";",lcRow,5)
             lnXX040=VAL(SUBSTR(lcRow,liS+1,liE-liS-1))
         
             INSERT INTO (loSettings.cAlias) (XX010, XX020, XX030, XX040) VALUE (lcXX010,lcXX020,lcXX030,lnXX040)
         NEXT
      ENDIF
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Save settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection,lcData
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      SELECT (loSettings.cAlias)
      lcData=""
      SCAN ALL
           lcData=lcData+"=;"+ALLTRIM(XX010)+";"+ALLTRIM(XX020)+";"+XX030+";"+LTRIM(STR(XX040,3))+";"+CHR(0)
      ENDSCAN
      =WriteINISection(lcSection+"_Items",@lcData,@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst) && Clone values properties of settings
      * loSrc - Source object
      * loDst - Destination object
      LOCAL loRam
      SELECT (loSrc.cAlias)
      SCAN ALL
           SCATTER NAME loRam MEMO
           INSERT INTO (loDst.cAlias) FROM NAME loRam
      ENDSCAN    
   ENDPROC


   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL lcPath,loPDMs,llRet
      loPDMs=EVAL(This.PDMs)
      lcPath=This.MainPath

*!*      This.Alias=SYS(2015)
*!*      llRet=loPDMs.OpenTable(This.DataSessionID,lcPath+"sc_mhhtml\words.dbf",This.Alias,"NOUPDATE ORDER revword")=0
*!*      IF llRet
*!*      ENDIF

      
      llRet=.T.
      RETURN llRet
   ENDPROC

   PROCEDURE CloseSources() && Close other source
      LOCAL loPDMs
      loPDMs=EVAL(This.PDMs)
*!*	      IF USED(This.cData)
*!*	         USE IN (This.cData)
*!*	      ENDIF

      RETURN .T.
   ENDPROC

   PROCEDURE InitResources(loSetting)
      * loSetting - Object of settings
      =DODEFAULT(@loSetting) && Voln pvodn metody
      RETURN .T.
   ENDPROC

   

ENDDEFINE

****************************************************************
DEFINE CLASS _vf_base_par AS _pdm_PlugIn_Parameter && Settings for plug-in
   Name="_vf_base_par"
   OK=.F.
   cAlias=""
   
*!*	   PROCEDURE Init(lcAlias)
*!*	      DODEFAULT()
*!*	      This.cAlias=lcAlias
*!*	      IF NOT USED(This.cAlias)
*!*	         CREATE CURSOR (This.cAlias) (XX010 M(4), XX020 M(4), XX030 C(1), XX040 I(4))
*!*	      ENDIF   
*!*	   ENDPROC   

   PROCEDURE Init()
      DODEFAULT()
      This.cAlias=SYS(2015)
      CREATE CURSOR (This.cAlias) (XX010 M(4), XX020 M(4), XX030 C(1), XX040 I(4))
      SELECT (This.cAlias)
      INDEX ON LEFT(XX010,50)+LEFT(XX020,50) TAG I01
   ENDPROC   
 
ENDDEFINE

