**************************************************************************
** Program name: go.PRG
** Version: 0.0.3
** Create date: 2004-08-22
** Description: Main program PDM 
** Author: Martina Jindrov
** E-mail: martin.jindra@egservis.cz
** CP: 1250


LPARAM luPar1,luPar2,luPar3,luPar4,luPar5,luPar6,luPar7,luPar8,luPar9,luPar10
*LPARAM lcFile,lcOutDir,lcPDM,lcLang,liSeverally
* lcFile   - Path and name PJX file
*            Seznam soubor pro kter se m vytvoit HTML dokumentace
*            Pokud je to seznam VFP projekt, pak se zpracuje pouze prvn
* lcOutDir - Out Dir HTML Doc
* lcPDM    - Path and name PDM file or files
* lcLang   - Path into folder with localization files
* liSeverally - Pznak generovn HTML doc. pro kad soubor zvl᚝
********************************************
LOCAL liCount,lii,liy,liID,lcPom,lcFile,lcOutDir,lcPDM,lcLang,liSeverally,;
      lcOpen,liSum,lcI,luVal,lcPrint,lcView,loRGUI,lcPom
LOCAL ARRAY laPar(11),laParN(11,3)


STORE "" TO lcFile,lcOutDir,lcPDM,lcLang,lcOpen,lcPrint,lcView
STORE 0 TO liSum,liSeverally

liCount=PCOUNT()

liID=0
IF liCount>0
   laParN(1,1)="lcFile"
   laParN(1,2)=1
   laParN(1,3)="--files"

   laParN(2,1)="lcOutDir"
   laParN(2,2)=2
   laParN(2,3)="--folder"

   laParN(3,1)="lcPDM"
   laParN(3,2)=3
   laParN(3,3)="--pdms"

   laParN(4,1)="lcLang"
   laParN(4,2)=4
   laParN(4,3)="--lang"

   laParN(5,1)="liSeverally"
   laParN(5,2)=5
   laParN(5,3)="--severally"

   laParN(6,1)="lcOpen"
   laParN(6,2)=6
   laParN(6,3)="--open"

   laParN(7,1)="lcPrint"
   laParN(7,2)=7
   laParN(7,3)="--print"

   laParN(8,1)="lcView"
   laParN(8,2)=8
   laParN(8,3)="--view"

   laParN(9,1)="lcPom"
   laParN(9,2)=9
   laParN(9,3)="--R"

   laParN(10,1)="lcPom"
   laParN(10,2)=10
   laParN(10,3)="--D"

   laParN(11,1)="lcCVP"
   laParN(11,2)=11
   laParN(11,3)="--cvp"


   FOR lii=1 TO liCount
       lcI=LTRIM(STR(lii,11))
       STORE LOWER(EVAL("luPar"+lcI)) TO  ("luPar"+lcI),luVal
       laPar(lii)=CheckParameter(luVal)
       liSum=BITOR(liSUM,IIF(laPar(lii)>0,2, IIF(EMPTY(luVal),0,1)))
   NEXT

   IF liSum=3
      * Input mischmatch
      * Get out
      ?"...Parameter PANIC"
      RETURN
   ENDIF

   IF liSum=2
      FOR lii=1 TO liCount
          liID=laPar(m.lii)
          liy=ASCAN(laParN,m.liID)
          IF liy>0
             liy=ASUBSC(laParN,m.liy,1)
             lcPom=SUBS(EVAL("luPar"+LTRIM(STR(m.lii,11))),LEN(laParN(m.liy,3))+1)
             IF INLIST(RIGHT(m.lcPom,1),["],['],"[")
                lcPom=SUBST(m.lcPom,2,LEN(m.lcPom)-2)
             ENDIF
             IF m.liID=5
                lcPom=VAL(m.lcPom)
             ENDIF
             STORE m.lcPom TO (laParN(m.liy,1))
          ENDIF
      NEXT
      * AS EXE parameters
   ENDIF
ENDIF

********************************************
* EXE parameters:
* --files[List of files]
* --folder[Output folder]
* --pdms[List of pdm files]
* --lang[Folder to langugae package]
* --severally[0/1]
* --open[one pdm file]
* --print[one pdm file]
* --view[one pdm file]
* --r
* --d



PUBLIC poPDMs,poPDM
=PDM_Initialize()

poPDMs=CREATEOBJECT("_PDMs","poPDMs",lcLang)
IF poPDMs.InitErr<0 && If any error
   RELE poPDMs && Then release variable
   RETURN .F. && and return
ENDIF
poPDMs.Initialize()
DO CASE
   * PDM File list
   CASE TYPE("lcPDM")="C" AND (AT(",",lcPDM)>0 OR !EMPTY(lcPDM) AND EMPTY(lcFile) AND EMPTY(lcOutDir) AND AT(",",lcPDM)=0)
        =poPDMs.GenerateFromPDMs(lcPDM)

   * Single PDM file
   CASE !EMPTY(lcFile) AND !EMPTY(lcOutDir) OR !EMPTY(lcPDM)
        * One or more files
        =poPDMs.GenerateFromPDM(lcPDM,lcFile,lcOutDir,IIF(TYPE("liSeverally")="N",IIF(liSeverally=0,0,1),0))
  
   * GUI 
   OTHERWISE
        loRGUI=CREATEOBJECT("_pdm_RunGUI")

        loRGUI.Command=liID
        DO CASE
           CASE liID=6
                loRGUI.Data=lcOpen

           CASE liID=7
                loRGUI.Data=lcPrint

           CASE liID=8
                loRGUI.Data=lcView

        ENDCASE
        =poPDMs.RunGUI("poPDMs","poPDM",loRGUI) && Show main form GUI

ENDCASE

RELE poPDM,poPDMs
=PDM_Release()


********************************************
PROCEDURE CheckParameter(luPar)
* luPar - Any Input parameter
RETURN IIF(LEFT(luPar,7)="--files",1,;
       IIF(LEFT(luPar,8)="--folder",2,;
       IIF(LEFT(luPar,6)="--pdms",3,;
       IIF(LEFT(luPar,6)="--lang",4,;
       IIF(LEFT(luPar,11)="--severally",5,;
       IIF(LEFT(luPar,6)="--open",6,;
       IIF(LEFT(luPar,7)="--print",7,;
       IIF(LEFT(luPar,6)="--view",8,;
       IIF(LEFT(luPar,3)="--R",9,;
       IIF(LEFT(luPar,3)="--D",10,;
       0))))))))))

