**************************************************************************
** Program name: PDMKernel.PRG
** Version: 0.0.1
** Create date: 2002-01-08
** Description: General procedures and functions for PDM
** Author: Martina Jindrov
** E-mail: martin.jindra@egservis.cz
** CP: 1250

#DEFINE ErrOther -1
#DEFINE ErrOK     0
#DEFINE CRLF CHR(13)+CHR(10)

******************************************************************************
PROCEDURE PDMKernel_WINAPIInit()
DECLARE INTEGER GetPrivateProfileString IN win32api STRING @Section, STRING @KeyName, STRING @Default, STRING @Buf, INTEGER BufLen, STRING @FileName
DECLARE INTEGER WritePrivateProfileString IN win32api	STRING @Section, STRING @KeyName, STRING @Buf, STRING @FileName
DECLARE INTEGER GetPrivateProfileInt IN win32api STRING @Section, STRING @KeyName, INTEGER , STRING @FileName
DECLARE INTEGER GetPrivateProfileSection IN win32api STRING @Section, STRING @Buf, INTEGER BufLen, STRING @FileName
DECLARE INTEGER WritePrivateProfileSection IN win32api STRING @Section, STRING @Buf, STRING @FileName
DECLARE INTEGER GetPrivateProfileSectionNames IN win32api STRING @Buf, INTEGER BufLen, STRING @FileName
DECLARE INTEGER GetThreadLocale IN kernel32.dll
DECLARE INTEGER ShellExecuteA IN shell32.dll INTEGER hwnd, STRING @ lpszOp, STRING @ lpszFile, STRING @ spszParams, STRING @ lpszDir, INTEGER fsShowCmd
DECLARE INTEGER GetActiveWindow IN WIN32API
DECLARE INTEGER GetDC           IN WIN32API INTEGER iHDC
DECLARE INTEGER ReleaseDC       IN WIN32API INTEGER ihwnd,INTEGER iHDC
DECLARE INTEGER GetDeviceCaps   IN WIN32API INTEGER iHDC, INTEGER iIndex
DECLARE         Sleep IN kernel32 INTEGER
DECLARE INTEGER WinExec IN kernel32 STRING @, INTEGER
DECLARE INTEGER SHGetSpecialFolderPath IN shell32.dll  INTEGER, STRING @, INTEGER, INTEGER
DECLARE INTEGER PathIsDirectory IN shlwapi.dll STRING @
DECLARE INTEGER GetFileAttributes IN win32api STRING @
DECLARE INTEGER SetFileAttributes IN win32api STRING @, INTEGER
DECLARE INTEGER FileTimeToSystemTime IN KERNEL32.DLL STRING @, STRING @
DECLARE INTEGER InternetCanonicalizeUrl IN wininet.dll STRING @lpszUrl, STRING @lpszBuffer, LONG @lpdwBufferLength, INTEGER dwFlags
DECLARE INTEGER OutputDebugString IN kernel32.dll STRING @
DECLARE INTEGER CoCreateGuid IN OLE32.Dll String @encodedid
DECLARE INTEGER StringFromGUID2 IN Ole32.DLL STRING rguid, STRING @lpsz, INTEGER cchMax
ENDPROC



***************************************************
* Source: http://fox.wikis.com/wc.dll?Wiki~GUID
***************************************************
PROCEDURE CreateGUID() && Crerate GUID
LOCAL lcGUIDBin,lcGUID,liLen
lcGUIDBin = SPACE(16)

IF CoCreateGuid(@lcGUIDBin)<>0
   RETURN .NULL.
ENDIF
  
lcGUID = REPLICATE( CHR( 0 ), 256 )
liLen= StringFromGUID2( lcGUIDBin, @lcGUID, 128) && Convert Binary GUID to string represantation
lcGUID = SUBSTR( lcGUID, 1, (liLen-1)*2)
RETURN STRCONV( lcGUID, 6 ) && Convert from UNICODE

***************************************************************
** Provede nhradu dcch znak HTML za nhradn entity
** Date: 2002-01-07 (MJ)
***************************************************************
PROCEDURE StrTranHTMLString(lcString)
* lcString - etzec, v ketrm se maj nahradit dc znaky HTML
RETURN STRTRAN(STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.lcString,"&","&amp;"),">","&gt;"),"<","&lt;"),'"',"&quot;"),"'","&#39;")
ENDPROC


PROCEDURE HTMLStringToStr(lcString)
* lcString - etzec, v ketrm se maj nahradit dc znaky HTML
RETURN STRTRAN(STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.lcString,"&amp;","&"),"&gt;",">"),"&lt;","<"),"&quot;",'"'),"&#39;","'")
ENDPROC

***************************************************************
** Pevod poloky Timestamp na DateTime
** Date: 2002-01-07 (MK)
***************************************************************
FUNCTION STAMP2DT(tnStamp)

#DEFINE Secondsmasks  0x0000001F
#DEFINE MinutesMasks  0x000007E0
#DEFINE HoursMasks    0x0000F800
#DEFINE DaysMasks     0x001F0000
#DEFINE MonthsMasks   0x01E00000
#DEFINE YearsMasks    0x3E000000

#DEFINE SecondsOffset  1
#DEFINE MinutesOffset  5
#DEFINE HoursOffset   11
#DEFINE DaysOffset    16
#DEFINE MonthsOffset  21
#DEFINE YearsOffset   25

#DEFINE t2Month      BITRSHIFT(BITAND(tnStamp, MonthsMasks),  MonthsOffset)
#DEFINE t2Day        BITRSHIFT(BITAND(tnStamp, DaysMasks),    DaysOffset)
#DEFINE t2Year  1980+BITRSHIFT(BITAND(tnStamp, YearsMasks),   YearsOffset)
#DEFINE t2Hour       BITRSHIFT(BITAND(tnStamp, HoursMasks),   HoursOffset)
#DEFINE t2Min        BITRSHIFT(BITAND(tnStamp, MinutesMasks), MinutesOffset)
#DEFINE t2Sec        BITRSHIFT(BITAND(tnStamp, Secondsmasks), SecondsOffset)
RETURN DATETIME(t2Year, t2Month, t2Day, t2Hour, t2Min, t2Sec)
ENDFUNC

********************************************************************
PROCEDURE NullTermined(lcChar)
LOCAL lii
lii=AT(CHR(0),m.lcChar) && najdi NULL znak v etzci
RETURN IIF(lii>0,LEFT(m.lcChar,lii-1),m.lcChar) && a oe to, pokud tam je
ENDPROC


******************************************************************************************
PROCEDURE C2ToI(lcInt)  && slo v etzcovm tvaru WINAPI 16 bit
RETURN ASC(LEFT(m.lcInt,1))+ASC(RIGHT(m.lcInt,1))*256  && vra slo v decimlnm tvaru
ENDPROC

********************************
PROCEDURE C4ToI(lcInt)  && slo v etzcovm tvaru WINAPI 32 bit
RETURN ASC(LEFT(m.lcInt,1))+;
       ASC(SUBS(m.lcInt,2,1))*256+;
       ASC(SUBS(m.lcInt,3,1))*65536+;
       ASC(RIGHT(m.lcInt,1))*256*65536  && vra slo v decimlnm tvaru
ENDPROC

********************************
PROCEDURE IToC4(liVal) && pevede slo na 4 bajtov etzec
LOCAL lcVal,lii

lii=INT(m.liVal/256) && vydl 256
lcVal=CHR(m.liVal-m.lii*256) && peve rozdl na znak a piti ho
liVal=lii && zapi novou hodnotu pro pevod

lii=INT(m.liVal/256) && vydl 256
lcVal=m.lcVal+CHR(m.liVal-m.lii*256)
liVal=m.lii && zapi novou hodnotu pro pevod

lii=INT(m.liVal/256) && vydl 256
lcVal=m.lcVal+CHR(m.liVal-m.lii*256)
liVal=m.lii && zapi novou hodnotu pro pevod

lii=INT(m.liVal/256) && vydl 256
RETURN m.lcVal+CHR(m.liVal-m.lii*256) && peve rozdl na znak a piti ho

********************************
PROCEDURE IToC2(liVal) && pevede slo na 2 bajtov etzec
LOCAL lcVal,lii

lii=INT(liVal/256) && vydl 256
lcVal=CHR(liVal-lii*256) && peve rozdl na znak a piti ho
liVal=lii && zapi novou hodnotu pro pevod

lii=INT(liVal/256) && vydl 256
RETURN lcVal+CHR(liVal-lii*256)


********************************
PROCEDURE C4ToL(lcLong)  && slo v etzcovm tvaru WINAPI 32 bit - signed
LOCAL liVal
liVal=ASC(LEFT(lcLong,1))+;
                  ASC(SUBS(lcLong,2,1))*256+;
                  ASC(SUBS(lcLong,3,1))*65536+;
                  ASC(RIGHT(lcLong,1))*16777216

RETURN IIF(liVal<=0x7FFFFFFF,liVal,liVal-(0xFFFFFFFF+1))


***********************************************************************************
PROCEDURE GetINIString(lcSection,lcKey,lcDVal,liBuf,lcFile)
LOCAL lcBuf,liLen
lcBuf=SPACE(m.liBuf)+CHR(0) && nastav buffer
lcSection=m.lcSection+CHR(0)
lcKey=m.lcKey+CHR(0)
lcFile=m.lcFile+CHR(0)
lcDVal=m.lcDVal+CHR(0)
liLen=GetPrivateProfileString(@lcSection,@lcKey,@lcDVal,@lcBuf,m.liBuf+1,@lcFile)
lcFile=STUFF(m.lcFile,LEN(m.lcFile),1,"")
RETURN LEFT(m.lcBuf,m.liLen)
ENDPROC

**************************************************************************************
PROCEDURE WriteINIString(lcSection,lcKey,lcVal,lcFile)
* zapi hodnotu
LOCAL liErr
*AB 2.5.2005
lcSection=IIF(ISNULL(m.lcSection),.NULL.,m.lcSection+CHR(0))
lcKey=IIF(ISNULL(m.lcKey),.NULL.,m.lcKey+CHR(0))
lcVal=IIF(ISNULL(m.lcVal),.NULL.,m.lcVal+CHR(0))
*/AB 2.5.2005
lcFile=m.lcFile+CHR(0)
liErr=WritePrivateProfileString(@lcSection,@lcKey,@lcVal,@lcFile)
lcFile=STUFF(m.lcFile,LEN(m.lcFile),1,"")
RETURN IIF(liErr>0,ErrOK,ErrOther)
ENDPROC

***********************************************************************************
PROCEDURE GetINISection(lcSection,liBuf,lcFile)
LOCAL lcBuf,liLen
lcBuf=SPACE(m.liBuf)+CHR(0) && nastav buffer
lcSection=m.lcSection+CHR(0)
lcFile=m.lcFile+CHR(0)
liLen=GetPrivateProfileSection(@lcSection,@lcBuf,m.liBuf,@lcFile)
lcFile=STUFF(m.lcFile,LEN(m.lcFile),1,"")
RETURN LEFT(m.lcBuf,m.liLen)
ENDPROC

***********************************************************************************
PROCEDURE GetINISectionNames(liBuf,lcFile)
LOCAL lcBuf,liLen
lcBuf=SPACE(m.liBuf)+CHR(0) && nastav buffer
lcFile=m.lcFile+CHR(0)
liLen=GetPrivateProfileSectionNames(@lcBuf,m.liBuf,@lcFile)
lcFile=STUFF(m.lcFile,LEN(m.lcFile),1,"")
RETURN LEFT(m.lcBuf,m.liLen)
ENDPROC

**************************************************************************************
PROCEDURE WriteINISection(lcSection,lcData,lcFile)
* zapi hodnotu
LOCAL liErr
lcSection=m.lcSection+CHR(0)
lcData=IIF(ISNULL(m.lcData),.NULL.,m.lcData+CHR(0))
lcFile=m.lcFile+CHR(0)
liErr=WritePrivateProfileSection(@lcSection,@lcData,@lcFile)
lcFile=STUFF(m.lcFile,LEN(m.lcFile),1,"")
RETURN IIF(liErr>0,ErrOK,ErrOther)
ENDPROC

***********************************************************************************
PROCEDURE GetINIInt(lcSection,lcKey,liDVal,lcFile)
LOCAL liVal
lcSection=m.lcSection+CHR(0)
lcKey=m.lcKey+CHR(0)
lcFile=m.lcFile+CHR(0)
liVal=GetPrivateProfileInt(@lcSection,@lcKey,@liDVal,@lcFile)
lcFile=STUFF(m.lcFile,LEN(m.lcFile),1,"")
RETURN liVal
ENDPROC

******************************************************************************
* Vrt hodnotu vlastnosti
******************************************************************************
PROCEDURE PEM_GetProperty(lcMem,lcProp)
* @lcMem  - etzec vlastnost
* lcProp  - Nzev vlastnosti


LOCAL lii,lcValue,liCRLF,liStart,lcCRLF
lcValue=.NULL. && Nastav hodnotu, pokud vlastnost nebyla nalezena

lcProp=UPPER(m.lcProp) && Peve na velk psmena
lii=AT(m.lcProp+" =",UPPER(m.lcMem))
IF lii=0
   lii=AT(m.lcProp+"=",UPPER(m.lcMem))
   liStart=m.lii+LEN(m.lcProp+"=")
   IF m.lii=0 && Pokud ji nenael
      RETURN m.lcValue && Pak se vra
   ENDIF
ELSE
   liStart=m.lii+LEN(m.lcProp+" =")
ENDIF

lcCRLF=CRLF
liCRLF=AT_Ex(@lcMem,@lcCRLF,m.liStart) && Najdi pozici nejbliho ENTERu
* ENTER tam nen
lcValue=IIF(m.liCRLF=0,SUBST(m.lcMem,m.liStart),SUBST(m.lcMem,m.liStart,m.liCRLF-m.liStart))

IF LEFT(m.lcValue,1)=" "
   lcValue=SUBST(m.lcValue,2)
ENDIF

* Pokud tam je ", pak jde o zkladn vlastnost VFP a typ C
IF LEFT(m.lcValue,1)=CHR(34)
   * A ty uvozovky se mus odstranit
   lcValue=SUBS(m.lcValue,2,LEN(m.lcValue)-2)
ENDIF

* Nebo pokud tam je (, pak jde o funkci
* A ty zvorky se mus odstranit

RETURN IIF(LEFT(m.lcValue,1)='(',"="+SUBS(m.lcValue,2,LEN(m.lcValue)-2),m.lcValue)
ENDPROC


******************************************************************************
* Vrt hodnotu XML vlastnosti
******************************************************************************
PROCEDURE PEM_GetXMLProperty(lcMem,lcProp)
* @lcMem  - etzec vlastnost
* lcProp  - Nzev vlastnosti
LOCAL lii,lcValue,liEnd,liStart,lcEnd
lcValue="" && Nastav hodnotu, pokud vlastnost nebyla nalezena

lii=ATC(m.lcProp+" =",UPPER(m.lcMem))
IF lii=0
   lii=ATC(m.lcProp+"=",UPPER(m.lcMem))
   liStart=m.lii+LEN(m.lcProp+"=")+1
   IF m.lii=0 && Pokud ji nenael
      RETURN m.lcValue && Pak se vra
   ENDIF
ELSE
   liStart=m.lii+LEN(m.lcProp+" =")+1
ENDIF

lcEnd='"'
liEnd=AT_Ex(@lcMem,@lcEnd,m.liStart) && Najdi pozici nejbliho ENTERu
IF liEnd=0
   RETURN ""
ENDIF   
RETURN SUBST(m.lcMem,m.liStart,m.liEnd-m.liStart)
ENDPROC

********************************
* Vrt slo verze VFP
PROCEDURE TABO_GetVersion
RETURN STRTRAN(SUBS(VERSION(),LEN("Visual FoxPro ")+1,2),"0","")
ENDPROC

****************************************************************
* Oprav zdrojov kd - ukon dky znaky CRLF
****************************************************************
PROCEDURE RepairSource(lcSource)
*@lcSource - Zdrojov kd

LOCAL liCR,liLF
* Zjisti, zda to nemus upravit
liCR=AT(CHR(13),m.lcSource,1)
liLF=AT(CHR(10),m.lcSource,1)
        
* Pokud tam nen pln CRLF, ale CR nebo LF
IF m.liCR=0 OR m.liLF=0
   * Pak to nahra CRLF
   lcSource=STRTRAN(m.lcSource,IIF(m.liCR=0,CHR(10),CHR(13)),CRLF)
ENDIF
ENDPROC
